#include "rectangle.hpp"

#include "texture_manager.hpp"
#include <gz-util/string/to_string.hpp>

namespace gz {
	Rectangle::Rectangle(float left, float top, float width, float height, std::unique_ptr<DrawStrategy<Rectangle>>&& drawStrategy)
        : position(left, top), size(width, height), drawStrategy(std::move(drawStrategy))
    {
        update();
    }

	std::string Rectangle::toString() const {
        return "<Rectangle pos: " + gz::toString(position) + ", size: " + gz::toString(size) + ">";
	}


	void Rectangle::update() {
        drawStrategy->update(*this);
	}


}  // namespace gz::vlk
