#pragma once

#include "buffer_manager.hpp"
#include <string>
#include "font.hpp"

namespace gz::vlk {
	class Text {
		public:
			Text(Font font, std::string&& text);
		private:
			std::string text;
			void setTextureCoordinates(FontManager& fontManager);

            uint32_t textureAtlasIndex;
			Font font;
            std::vector<Vertex2D> vertices;
            std::vector<uint32_t> indices;

            BufferInfo vertexBufferInfo;
            BufferInfo indexBufferInfo;
			std::string toString() const;
	};

}  // namespace gz::vlk
